( *** NAXOS System-Vocabulary Version 1.0 *** )

( Name:    nxfile.FTH )
( Version: 1.0           )
( Datum:   9.9.88        )
( Autor:   Volker Everts )
(          Klaus Peper   )
( Neu      2.6.91        )


( ********************* )
( ***** FILE.FTH: ***** )
( ********************* )


include    xkern
^

: DOS>$$  (  => ?:? )
          ( adr => )
( ** bertrgt ASCIIZ-String nach PAD+1     ** )
( ** Count-Byte bei PAD wird gesetzt        ** )
( ** bertrgt solange, bis 0-Byte gefunden ** )
( ** Jedoch nicht mehr als 255 Byte         ** )
     bx>r dx 255 0 .scan. 
     bx>dx r xchg - 
     pad c! 
     bx+ bx>dx r>bx cmove
;

: ($PTR)  ( => ? )
          ( str -- )
( ** Erzeugt Zeiger auf String in DS:DX ** )
( ** String mu ASCIIZ-Format haben!    ** )
  bx> 1+ r.dx !  cs@  r.ds !  
;



( *** Laufwerks- und Verzeichnis-Funktionen *** )


: drive!  ( n => )
          ( -- )
( ** aktuelles Laufwerk setzen, A=1, B=2, ... ** )
  1- r.dx ! $0E msdos
;


: drive@  ( => n )
          ( -- )
( ** aktuelles Laufwerk holen, A=1, B=2, ... ** )
  $19 msdos r.ax c@ 1+ 
;


: mkdir  ( str => )
         ( -- )
( ** Verzeichnis anlegen ** )
  ($PTR) $39 ?msdos
;


: rmdir  ( str => )
         ( -- )
( ** Verzeichnis lschen ** )
  ($PTR) $3A ?msdos
;


: chdir  ( str => )
         ( -- )
( ** Verzeichnis wechseln ** )
  ($PTR) $3B ?msdos
;


: path>$$  ( n => )
           ( -- )
( ** Verzeichnisnamen nach PAD bringen ** )
( ** n := gewnschtes Laufwerk         ** )
  r.dx c!
  pad bx> 1+ r.si !
  cs@ r.ds ! r.es !
  $47  ?msdos 
  pad DOS>$ 
;



: me>$$  ( => )
          ( -- )
( ** Programmnamen holen              ** )
( ** nicht dokumentierte DOS-Funktion ** )
  $52 msdos
  r.bx @ , 4 + r.es @>dx ~d@
  dx>tx dx $C4 + tx>dx fptr d!
  cs@ >dx pad bx> vptr d! 
  fptr to vptr 14 ^cmove
  pad $>dos
  32 pad c! pad bx> nextscan !
  .parse. 
;

: parm>$$  ( => )
           ( -- )
( ** Parameterstring nach PAD bringen ** )
( ** dta bei $80, noch nicht verlegt  ** )
  ADR dta >$$ pad $>DOS
;

: ?parm  ( => n )
         ( -- )
( ** Zahl der Kommandozeile-Parameter ** )
 parm>$$ 
  $20 pad c!
  pad bx> nextscan !
  sx 0 begin .parse. while sx+ repeat pop
;

proc .iparm.  ( i => ) ( f )
            ( -- str )
( ** i.Parameter holen     ** )
( ** f:= 0: nicht gefunden ** )
( ** i:= 0 ergibt Namen    ** )
  >r
  parm>$$ 
  $20 pad c!  pad bx> nextscan !
  r> , 1 do .parse. .not.
  if 1 >tx leave else 0 >tx endif loop
  dx>bx tx> .0=.
;

: .parm ( => )
          ( -- )
( ** Drucke alle Kommandozeile-Parameter ** )
  ?parm >tx .0=. if ." Kein Parameter" exit endif
  tx> , 1 DO cr
  i . ." .Parameter: " 
  i .iparm. $.  
  LOOP cr
;


( *** Datei-Funktionen *** )


: create  ( str n => )
          ( -- )
( ** Datei neu anlegen       ** )
( ** oder vorhandene leeren  ** )
( ** n=0 := Read/Write Datei ** )
( ** n=1 := Read only Datei  ** )
  r.cx ! ($PTR) $3C ?msdos
;


: ?exist  ( str => f )
          ( -- )
( ** prft, ob Datei existiert ** )
( ** f:=1 Datei existiert      ** )
  ($PTR) 0 r.ax ! $3D msdos
  r.flags @ , 1 and
  .0=. if .F.
  else r.ax @ r.bx ! $3E msdos .T.
  endif
;


: open  ( str n1 => n2 )
        ( => )
( ** Datei ffnen    ** )
( ** str:= Dateiname ** )
( ** n2:= handle     ** )
( ** n1:= mode :     ** )
( ** 0 := Read only  ** )
( ** 1 := Write only ** )
( ** 2 := Read/Write ** )
  r.ax ! ($PTR) $3D ?msdos r.ax @
;


: close  ( n => )
         ( => )
( ** Datei mit Handle n schlieen ** )
  r.bx ! $3E ?msdos
;


: kill  ( str => )
        ( => )
( ** Datei lschen                ** )
( ** Datei muss geschlossen sein! ** )
( ** Sonst Fehler in DOS !        ** )
  ($PTR) $41 ?msdos
;


: rename  ( str_neu2 => ?:? )
          ( str_alt => ? )
( ** Datei umbenennen ** )
  dx+ bx> 1+ r.dx ! 
  cs@ r.es ! r.ds !
  r.di dx>! $56 ?msdos
;

: drivespace ( n => n2:n1  )
             ( => ? )
             ( => n4 n3 )
( ** Freien Speicherraum der Platte ermitteln     ** )
( ** n:= 0 current drive; 1 = A ...               ** )
( ** n1:= Zahl Sektoren/Cluster | -1 if n invalid ** )
( ** n2:= Zahl der freien Cluster                 ** )
( ** n3:= Bytes/Sektor                            ** )
( ** n4:= Gesamtkapazitt des Drives in Cluster   ** )
  r.dx ! $36 msdos
  r.dx @ push r.cx @ push r.bx @>dx r.ax @
;

: dta@  ( => seg:offs )
        ( => ? )
( ** Disk-Transfer-Adresse holen ** )
  $2F msdos r.es @>dx r.bx @
;

: dta!  ( seg:offs => ?:? )
        ( => ? )
( ** Disk-Transfer-Adresse setzen ** )
  r.ds dx>!  r.dx ! $1A msdos
;


: handle-dup  ( n1 => n2 )
              ( => )
( ** zweiten Dateihandle einrichten ** )
  r.bx ! $45 ?msdos r.ax @
;


: handle-assgn  ( n1:n2 => ?:? )
                ( => )
( ** Handle n2 an Handle n1 angleichen ** )
  r.cx ! r.bx dx>! $46 ?msdos
;


: file-attr@  ( => ?:n )
              ( str => )
( ** Dateiattribut n lesen ** )
( ** n:=0 unbeschrnkter Zugriff               ** )
( ** n:=8 Name des Mediums [ Vol. ID ]         ** )
( ** Bit0 = 1 : Datei kann nur gelesen werden  ** )
( ** Bit1 = 1 : Verborgene Datei               ** )
( ** Bit2 = 1 : Systemdatei                    ** )
( ** Bit4 = 1 : Subdirektory                   ** )
( ** Bit5 = 1 : Datei seit Sicherung verndert ** )
  ($PTR) 0 r.ax ! $43 ?msdos r.cx @
;


: file-attr!  ( -:n => ?:? )
              ( str => )
( ** Dateiattribut n ndern ** )
( ** n:=0 unbeschrnkter Zugriff              ** )
( ** n:=8 Name des Mediums [ Vol. ID ]        ** )
( ** Bit0 = 1 : Datei kann nur gelesen werden ** )
( ** Bit1 = 1 : Verborgene Datei              ** )
( ** Bit2 = 1 : Systemdatei                   ** )
( ** Bit4 = 1 : Subdirektory                  ** )
  ($PTR) r.cx ! 1 r.ax ! $43 ?msdos
;


( ** Directory-Suchfunktionen ** )

: dirfirst  ( n => )
            ( str => )
( ** ersten Dateieintrag mit Attribut n suchen ** )
( ** str1:= Suchstring, * und ? gltig         ** )
( ** Gefundener String in PAD                  ** )
( ** n:=0       unbeschrnkter Zugriff         ** )
( ** n:=8       Name des Mediums [ Vol. ID ]   ** )
( ** Bit0 = 1 : Read only-Datei                ** )
( ** Bit1 = 1 : Verborgene Datei               ** )
( ** Bit2 = 1 : Systemdatei                    ** )
( ** Bit4 = 1 : Subdirektory                   ** )
( ** Bit5 = 1 : Datei seit Sicherung verndert ** )
  >tx  ($PTR)  tx> r.cx !  $4E msdos 
  dosflag
  c@if
    0 pad c!    ( Leerstring erzeugen )
  else
    dta@ , $1E + >bx DOS>$$  ( String nach PAD )
  endif
;


: dirnext  ( => )
           ( => )
( ** nchsten Dateieintrag suchen ** )
( ** Gefundener String in PAD     ** )
  $4F msdos
  dosflag
  c@if
    0 pad c!        ( Leerstring erzeugen )
  else
    dta@ , $1E + >bx DOS>$$ ( String nach PAD )
  endif
;

: dirattr  ( => n )
           ( => )
( ** Attribut einer gefundenen Datei ** )
  dta@ , $15 + >bx c@
;

: dirtime  ( => n )
           ( => )
( ** Zeit der Dateierstellung                ** )
( ** n:= h h h h h m m m   m m m s s s s s   ** )
( ** h:= Stunde, m:= Minute, s:= 1/30 Minute ** )
  dta@ , $16 + >bx @
;

: dirdate  ( => n )
           ( => )
( ** Datum der Dateierstellung              ** )
( ** n:= J J J J J J J M   M M M T T T T T  ** )
( ** J:= Jahr ausgehend von 1980            ** )
( ** M:= Monat 1 -12                        ** )
( ** T:= Tag 1 - 31                         ** )
  dta@ , $18 + >bx @
;

: dirsize  ( => d )
           ( => )
( ** Gre der ermittelten Datei ** )
  dta@ , $1a + >bx d@
;


( ** Weitere Systemfunktionen ** )

: sysdate  ( => n2:n1 )
           ( => )
           ( => n4 n3 )
( ** hole Datum                 ** )
( ** n1:= Wochentag 0 = Sonntag ** )
( ** n2:= Tag 1 - 31            ** )
( ** n3:= Monat 1 - 12          ** )
( ** n4:= Jahr 1980 - 2099      ** )
  $2a msdos r.cx @ push r.dx @ split  
  dxpush >tx r.ax @ , 255 and tx>dx 
; 

: .date ( => )
           ( -- )
( ** Gib Datum aus ** )
  sysdate dx> u. ." ." pop u. ." ." pop u.
;

(long)
: .date+  ( => )
           ( -- )
( ** Gib Datum mit Wochentag aus ** )
 sysdate 2drop
 case 0 of ." Sonntag, " ;;
      1 of ." Montag, " ;;
      2 of ." Dienstag, " ;;
      3 of ." Mittwoch, " ;;
      4 of ." Donnerstag, " ;;
      5 of ." Freitag, " ;;
      6 of ." Samstag, " ;;
  endcase .date
; 
(short)

: systime  ( => n1:n2 )
           ( => )
( ** hole Systemzeit                    ** )
( ** n1:= Highbyte = h   Lowbyte = min  ** )
( ** n2:= Highbyte = sec Lowbyte = csec ** )
  $2c msdos r.cx @>dx r.dx @ 
;

: .time ( => )
           ( -- )
( ** Gib Zeit aus ** )
  systime  dx> split push dx> u. ." :" pop u. 
;


( ** TIMER ** )

var csec double ( centisekunden ) ;

: (csec)  ( d => d )
          ( => )
( ** Wandelt Zeit in Centisekunden ** )
  >tx        ( ax retten )
  dx> split  ( h:min )
  push sx 0  ( min retten )
  , 60 *     ( h>min )
  d+         ( h+min in min )
  dpop
  sx 60
  du*        ( in sec )
  dpush
  tx>        ( sec:csec )
  split
  >bx        ( csec retten )
  dx> n>d d+ ( addieren )
  dpop
  d10* d10*  ( centisec )
  dpush
  bx> n>d d+ ( addieren )
  dpop
;

: 0timer  ( => ) ( -- )
( ** Start Timer ** )
  systime csec d!
;


: .timer  ( => )
          ( -- )
( ** Gib Zeit seit 0timer in Sec aus ** )
  systime (csec) dpush csec d@ (csec) dminus d+ 
  cr ." t = " dpop <# # # '.' hold #s #>
  type ."  sec" 
;

dictionary 


: main init ." NAXOS-FILE-Wrterbuch"   
  wait  ;



