

( *** Naxos System-Vocabulary Version 1.0 *** )

( Name:    kern.fth       )
( Version: 1.0            )
( Datum:   9.9.88         )
( Autor:   Klaus Peper    )
( Neu      04.02.92       )


( ------------------------------------- )
( NAXOS V2.01                           )
( basiert auf MCC sowie auf SFORTH 4.1  )
( SForth ist ein Software-Projekt von   )
( DOS International. Beschreibung siehe )
( DOS International Ausgabe 9/87 ff und )
( DOS Extra 2/88.                       )
(                                       )
( Autoren: Volker Everts                )
(   Erwin Schomburg                     )
(   Klaus Peper                         )
(                                       )
( ------------------------------------- )




(short)

( ** System - Adressen ** )
const  entry   $102 ( Main           ) ;
const  r0      $104 ( Returnpointer  ) ;
const  s0      $106 ( Stackpointer   ) ;
const  dp      $108 ( Codeende       ) ;
const  inreg   $110 ( Registerrecord ) ;
const  dosflag $12E ( Fehlerflag     ) ;
const  exno    $12D ( Errorexbyte    ) ;
const  ex&cls  $1AD ( Exit+CLS       ) ;
const  ex&hop  $1B4 ( Exitadresse    ) ;

( ** Weitere interne Adressen : ** )
( ** $12A:  spsave              ** )
( ** $12F:  Breakbyte           ** )
( ** $12E:  Mousebyte           ** )
( ** $10A-10F frei              ** )
( ** $134-13F frei              ** )



( *** Variablen - Definitionen ** )

typ  Byte   [ 0 c, ]  ( Byte ) ;
typ  Word   Byte 2    ( Word ) ;
typ  fptr   word 2    ( Farpointer ) ; 
typ  double word 2    ( Double ) ;
typ  nptr   word do:  ( Nearpointer )
     [ $8B $1F ]      ( mov bx,[bx] ) ;
typ  arr word do:     ( Wordarray )
     [ $D1 $E2 ]      ( shl dx,1 )
     [ $01 $D3 ]      ( add bx,dx ) ;
typ  carr Byte do:    ( Bytearray, DX:= Index i )
     [ $01 $D3 ]      ( add bx,dx ) ;
     
          
( *** System-Variablen *** )


var base    [ 10 , ]     ( Zahlenbasis ) ;
var hld     word         ( Zeiger auf Ziffer ) ;
var dpl     word         ( Zeiger auf Dezimalpunkt ) ;
var leading word         ( enthlt fhrende Null oder Space ) ;
var out     word         ( Zeichenzhler fr EMIT ) ;
var in      word         ( Zeichenzhler Eingabe ) ;
var (crlf)  [ $0D0A , ]  ( Return-Linefeed ) ;

var vptr    fptr         ( Video-ptr ) ;
var csptr   fptr         ( Codeseg-ptr ) ;

var   dosfkt Byte    ( DOS-Funktion ) ;
( Registerrecord fr INTR-interface: ) 
var   r.ax   word     10  ( Register AX  ) ;
: r.bx  r.ax offset    2  ( Register BX  ) ;
: r.cx  r.ax offset    4  ( Register CX  ) ;
: r.dx  r.ax offset    6  ( Register DX  ) ;
: r.bp  r.ax offset    8  ( Register BP  ) ;
: r.si  r.ax offset   10  ( Register SI  ) ;
: r.di  r.ax offset   12  ( Register DI  ) ;
: r.ds  r.ax offset   14  ( Register DS  ) ;
: r.es  r.ax offset   16  ( Register ES  ) ;
: r.flags r.ax offset 18  ( Flagregister ) ;



( *** System-Vektoren *** )

vector doserr ( Fehlervektor fr DOS-Funktionen ) ;
vector emit   ( Zeichen ausgeben ) ;
vector type   ( String ausgeben ) ;
vector key    ( Zeichen eingeben ) ;
vector ?key   ( Taste gedrckt ? ) ;
vector expect ( Zeile eingeben ) ;
vector break  ( Control-C-Handler ) ;
vector int0   ( Division durch Null ) ;



( *** System-Konstanten *** )

const bl   32  ( Leerzeichen ) ;
const bs   8   ( Backspace ) ;
const dta  $80 ( Disk-Transfer-Area ) ;


( ** Handle-variable ** )
var  #stdout   [ 2 , ]    ( outhandle ) ;
var  #stdin    [ 0 , ]    ( inhandle ) ;
var  #hold     [ 2 , ]    ( temp. handle ) ;
var  #fin      [ 0 , ]    ( Eingabe-Textdatei ) ;
var  #fout     [ 1 , ]    ( Ausgabe-Textdatei ) ;
var  #fi/o     [ 3 , ]    ( Direktzugriffsdatei ) ;




( ********************************* )
( * Worte, Funktionen, Operatoren * )
( ********************************* )


: ###  ( => )
( **    Setze Breakpoint    ** )
( BR-Routine vorher aktivieren )
  [ $CC ]
;


( *** Registerbefehle *** )

: >bx  ( -:adr => -:adr )
       ( => adr )
( ** Accu nach BX kopieren ** )
[ $89 $C3 ] ( mov bx,ax )
;

: bx>  ( -:- => -:adr )
       ( adr => adr )
( ** BX nach Accu kopieren ** )
[ $89 $D8 ]  ( mov ax,bx )
;

: bx>+  ( -:n => -:n+adr )
        ( adr => adr )
( ** Addiere Adresse zu n ** )
[ $01 $D8 ] ( add ax,bx )
;

: >bx+  ( -:n => -:n )
        ( adr => adr+n )
( ** Erhhe Adresse um n ** )
[ $01 $C3 ] ( add bx,ax )
;

: bx+  ( -:- )
       ( adr => adr+1 )
( ** Erhhe Adresse um 1 ** )
[ $43 ]
;

: hibyte  ( -:- )
          ( adr => adr+1 )
( ** Erhhe Adresse um 1 ** )
[ $43 ]
;

: bx++  ( -:- )
        ( adr => adr+2 )
( ** Erhhe Adresse um 2 ** )
[ $43 $43 ]
;

: hiword  ( -:- )
          ( adr => adr+2 )
( ** Erhhe Adresse um 2 ** )
bx++
;

: bx-  ( -:- )
       ( adr => adr-1 )
( ** Adresse um 1 erniedrigen ** )
[ $4B ]
;

: bx--  ( -:- )
        ( adr => adr-2 )
( ** Adresse um 2 erniedrigen ** )
bx- bx- 
;

: bx>dx  ( -:- => adr:- )
         ( adr => adr )
( ** BX nach DX kopieren ** )
[ $89 $DA ] ( mov dx,bx )
;

: dx>bx  ( adr:- => adr:- )
         ( => adr )
( ** Lade Adresse aus DX ** )
[ $89 $D3 ] ( mov bx,dx )
;

: bx>r  ( -:- )
        ( adr => adr )
( ** adr auf Returnstack ** )
[ $53 ]  ( push bx )
; 

: r>bx  ( -:- )
        ( => adr )
( ** adr von Returnstack ** )
[ $5B ]  ( pop bx )
;

: >dx  ( -:n => n:n )
       ( => )
( ** ax nach dx kopieren ** )
[ $89 $C2 ]  ( mov dx,ax )
;

: dx>  ( n:- => n:n )
       ( => )
( ** dx nach ax kopieren ** )
[ $89 $D0 ]  ( mov ax,dx )
;

: dx2*  ( n:- => 2n:- )
        ( => )
( ** DX verdoppeln ** )
[ $D1 $E2 ] ( shl dx,1 )
;

: dx>r  ( n:- => n:- )
        ( => )
( ** DX nach Returnstack kopieren ** )
[ $52 ]  ( push dx )
;

: r>dx  ( -:- => n:- )
        ( => )
( ** DX vom Returnstack holen ** )
[ $5A ] ( pop dx )
;

: xchg  ( n1:n2 => n2:n1 )
        ( => )
( ** Exchange AX mit DX ** )
[ $92 ]
;

: dx+  ( n:- => n+1:- )
       ( => )
( ** DX-Register erhhen ** )
[ $42 ] ( inc dx )
;

: dx-  ( n:- => n-1:- )
       ( => )
( ** DX-Register erniedrigen ** )
[ $4A ] ( dec dx )
;

: 0>dx  ( -:- => 0:- )
        ( => )
( ** DX-Register auf 0 ** )
[ $31 $D2 ] ( xor dx,dx )
;

: -1>dx ( -:- => -1:- )
        ( => )
( ** DX-Register auf -1 ** )
0>dx dx-
;

: >r   ( -:n => -:n )
       ( => )
( ** Accumulatorwert auf Returnstack ** )
[ $50 ] ( push ax )
;

: r>   ( => -:n )
       ( => )
( ** Wert vom Returnstack holen ** )
[ $58 ] ( pop ax )
;


: r  ( => -:n )
     ( => )
( ** Wert vom Returnstack kopieren ** )
r> [ $50 ] ( push ax )
;

: >tx  ( -:n )
       ( => )
( ** Accu nach ES kopieren ** )
[ $8E $C0 ]  ( mov es,ax )
;

: tx>  ( -:- => -:n )
       ( => )
( ** ES nach Accu kopieren ** )
[ $8C $C0 ]  ( mov ax,es )
;
 
: bx>tx  ( -:- )
         ( n => n )
( ** BX nach ES kopieren ** )
[ $8E $C3 ]  ( mov es,bx )
;

: tx>bx  ( -:- )
         ( ? => n )
( ** ES nach BX kopieren ** )
[ $8C $C3 ]  ( mov bx,es )
;

: dx>tx  ( n:- )
( ** DX nach ES kopieren ** )
[ $8E $C2 ] ( mov es,dx )
;

: tx>dx  ( -:- => n:- )
( ** ES nach DX kopieren ** )
[ $8C $C2 ] ( mov dx,es )
;

: sx+  ( => )
       ( => )
       ( n => n+1 )
( ** increase TOS ** )
[ $FF $04 ]
;


( *** Datenstack-Manipulation *** )

: drop  ( => )
        ( => )
        ( n => )
( ** Stackwert entfernen ** )
[ $46 ] ( inc si )
[ $46 ] ( inc si )
;

: 2drop ( => )
        ( => )
        ( n2 n1 => )
( ** 2 Stackwerte entfernen ** )
drop drop 
;

: iload   ( -:i => -:ni )
          ( => )
          ( .. ni .. n1 => .. ni .. n1 )
( ** Kopiere i.ten Stackwert in Accu ** )
[ $53 ]     ( push bx )
[ $48 ]     ( dec ax )
[ $D1 $E0 ] ( shl ax,1 )
[ $89 $C3 ] ( mov bx,ax )
[ $8B $00 ] ( mov ax,[si+bx] )
[ $5B ]     ( pop bx )
;


: 1load  ( -:- => -:n )
         ( => )
         ( n => n )
( ** Kopiere 1. Stackwert in Accu ** )
[ $8B $04 ] ( mov ax,[si] )
;

: 2load ( -:- => -:n2 )
        ( => )
        ( n2 n1 => n2 n1 )
( ** Kopiere 2. Stackwert in Accu ** )
[ $8B $44 $02 ] ( mov ax,[si+2] )
;

: store  ( -:n => -:n )
         ( => )
         ( ? => n )
( ** Accu in 1. Stackwert laden ** )
[ $89 $04 ] ( mov [si],ax )
;

: push  ( -:n => -:n )
        ( => )
        ( => n )
( ** Accuwert auf Stack: push ** )
[ $4E $4E ] ( dec si, dec si )
[ $89 $04 ] ( mov [si],ax    )
;

: bxpush ( -:n => -:n )
         ( => )
         ( => n )
( ** BXwert auf Stack: push ** )
[ $4E $4E ] ( dec si dec si )
[ $89 $1C ] ( mov [si],bx )
;

: dxpush ( -:n => -:n )
         ( => )
         ( => n )
( ** DXwert auf Stack: push ** )
[ $4E $4E ] ( dec si dec si )
[ $89 $14 ] ( mov [si],dx )
;

: pop  ( -:- => -:n )
       ( => )
       ( n => )
( ** Stack nach Accu : pop ** )
[ $AD ] ( lodsw )
;

: bxpop ( -:- )
        ( => n )
        ( n => )
( ** Stackwert nach BX: pop ** )
[ $8B $1C ] ( mov bx,[si] )
[ $46 $46 ] ( inc si inc si )
;

: dxpop ( -:n )
        ( => )
        ( n => )
( ** Stackwert nach DX: pop ** )
[ $8B $14 ] ( mov dx,[si] )
[ $46 $46 ] ( inc si inc si )

;

: dload  ( -:- => n1:n2 )
         ( => )
         ( n2 n1 => n2 n1 )
( ** Doppelwort aus Stack kopieren ** )
[ $8B $14 ]     ( mov dx,[si] )
[ $8B $44 $02 ] ( mov ax,[si+2] )
;

: dpop  ( -:- => n1:n2 )
        ( => )
        ( n2 n1 => )
( ** Doppelwort aus Stack: pop ** )
dload 2drop
;

: dstore  ( n1:n2 => n1:n2 )
          ( => )
          ( ? ? => n1 n2 )
( Doppelwort in oberste Stackwerte kopieren ** )
[ $89 $14 ]      ( mov [si],dx   )
[ $89 $44 $02 ]  ( mov [si+2],ax )
;

: dpush  ( n1:n2 => n1:n2 )
         ( => )
         ( => n2 n1 )
( ** Doppelwort auf Stack: push ** )
[ $83 $EE $04 ] ( dec si dec si )
dstore
;


( *** einfache Arithmetik *** )


: +   ( n2:n1 => n2:n' )
      ( => )
      ( => )
( ** Summe n':= n2 + n1 ** )
[ $01 $D0 ] ( add ax,dx )
;


: -   ( n2:n1 = n2:n' )
      ( => )
      ( => )
( ** Differenz n':= n2 - n1 ** )
[ $29 $D0 ] ( sub ax,dx )
;


: *   ( n2:n1 => d )
      ( => )
      ( => )
( ** Produkt d := n2*n1 ** )
[ $F7 $EA ] ( imul dx )
;

: 2*  ( -:u => -:2u )
      ( => )
( ** Multiplikation mit 2      ** )
( ** Schnelle Adressberechnung ** )
[ $D1 $E0 ] ( shl ax,1 )
;

: 10*  ( -:n => -:10n )
       ( => )
( ** Schnelle Multiplikation mit 10 ** )
[ $D1 $E0 ]  ( shl ax,1 )
[ $89 $C7 ]  ( mov di,ax )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $E0 ]  ( shl ax,1 )
[ $01 $F8 ]  ( add ax,di )
;

: /  ( n2:n1 => r:q )
     ( => )
( ** Quotient q := n1/n2, Rest r ** )
[ $89 $D7 ] ( mov  di,dx )
[ $99 ]     ( cwd        )
[ $F7 $FF ] ( idiv di    )
;

: u2/  ( -:u => -:u/2 )
       ( => )
( ** Division durch 2     ** )
( ** Schnelle Skalierung  ** )
[ $D1 $E8 ] ( shr ax,1 )
;

: d/  ( ud => ud' )
      ( => )
      ( u => r )
( ** Qotient ud':= d/u, Rest r ** )
[ $87 $1C ] ( xchg bx,[si] )
[ $89 $C7 ] ( mov  di,ax   )
[ $89 $D0 ] ( mov  ax,dx   )
[ $31 $D2 ] ( xor  dx,dx   )
[ $F7 $F3 ] ( div  bx      )
[ $97 ]     ( xchg ax,di   )
[ $F7 $F3 ] ( div  bx      )
[ $89 $D3 ] ( mov  bx,dx   )
[ $89 $FA ] ( mov  dx,di   )
[ $87 $1C ] ( xchg bx,[si] )
;


: */  ( n3:n2 => r:n' )
      ( => )
      ( n1 => )
( *  Skalierung ber doppeltgenaues Produkt  * )      
( *  n' := n3*n2/n1, r := rest               * )
[ $F7 $EA ] ( imul dx     )
[ $8B $3C ] ( mov di,[si] )
[ $F7 $FF ] ( idiv di     )
drop
;


: n>d  ( -:n => d )
       ( => )
( ** einfache Zahl -> doppelt genau ** )
[ $99 ]     ( cwd  )
;

: u>d  ( -:u => d )
       ( => )
( ** Einfache Zahl ohne Vorzeichen in Doppelzahl ** )
dx 0
;

: dminus  ( d => -d )
          ( => )
( ** Vorzeichenwechsel ** )
[ $F7 $D0 ]   ( not ax    )
[ $F7 $D2 ]   ( not dx    )
[ $05 1 0 ]   ( add ax,1  )
[ $83 $D2 0 ] ( adc dx,0  )
;

: d+  ( d1 )
      ( => )
      ( d2 => d' )
( ** Summe d':= d2 + d1 ** )
[ $01 $44 2 ] ( add [si+2],ax ) 
[ $11 $14 ]   ( adc [si],dx   ) 
;

: du*  ( ud => ud' )
       ( => ? )
       ( u => )
( ** Doppelwort mit u multiplizieren ** )
[ $8B $1C ]  ( mov  bx,[si] )
[ $89 $14 ]  ( mov  [si],dx )
[ $F7 $E3 ]  ( mul  bx      )
[ $87 $04 ]  ( xchg [si],ax )
[ $89 $D7 ]  ( mov  di,dx   )
[ $F7 $E3 ]  ( mul  bx      )
[ $89 $C2 ]  ( mov  dx,ax   )
pop
[ $01 $FA ]  ( add  dx,di   )
;

: d2*  ( ud => 2*ud )
       ( => )
( ** Doppelwort shift left ** )
[ $D1 $E0 ]  ( shl ax,1 )
[ $D1 $D2 ]  ( rcl dx,1 )
;

: d10*  ( d => 10d )
        ( => )
( Doppelwort mal 10 ** )
[ $51 ]      ( push cx )
d2*
[ $89 $C1 ]  ( mov cx,ax )
[ $89 $D7 ]  ( mov di,dx )
d2*
d2*
[ $01 $C8 ]  ( add ax,cx )
[ $11 $FA ]  ( adc dx,di )
[ $59 ]      ( pop cx )
;

: d16*  ( d => 16d )
        ( => )
( ** Doppelwort mal 16 ** )
d2*
d2*
d2*
d2*
;



: and ( n2:n1 => n2:n' )
      ( => )
( ** n':= n2 AND n1 ** )
[ $21 $D0 ] ( and ax,dx )
;


: or  ( n2:n1 => n2:n' )
      ( => )
( ** n':= n2 OR n1 ** )
[ $09 $D0 ] ( or ax,dx )
;


: xor ( n2:n1 => n2:n' )
      ( => )
( ** n':= n2 XOR n1 ** )
[ $31 $D0 ] ( xor ax,dx )
;


: minus  ( -:n => -:n' )
         ( => )
( ** Vorzeichenwechsel ** )
[ $F7 $D8 ] ( neg  ax )
;


: not  ( -:n => -:n' )
       ( => )
( **  Komplement bilden ** )
[ $F7 $D0 ] ( not  ax )
;


: 1+  ( -:n => -:n+1 )
      ( => )
( ** Accu plus 1 ** )
[ $40 ]  ( inc ax )
;


: 2+  ( -:n => -:n+2 )
      ( => )
( ** Accu plus 2 ** )
1+ 1+
;


: 1-  ( -:n => -:n-1 )
      ( => )
( ** Accu minus 1 ** )
[ $48 ]  ( dec ax )
;


: 2-  ( -:n => -:n-2 )
      ( => )
( ** Accu minus 2 ** )
1- 1-
;



( *** Speicher-Befehle *** )

: @  ( -:- => -:n )
     ( adr => adr )
( ** Wort aus adr holen ** )
[ $8B $07 ] ( mov ax,[bx] )
;

: @>bx  ( => )
        ( adr => adr' )
( ** Adresse aus Nearpointer laden  ** )
( ** Entspricht:  @ ax>bx           ** )
[ $8B $1F ]   ( mov bx,[bx] )
;

: @>dx  ( -:- => n:- )
        ( adr => adr )
( ** Wort von adresse nach DX ** )
[ $8B $17 ] ( mov dx,[bx] )
;

: c@  (  -:- => -:c )
      ( adr => adr )
( ** Byte aus adr holen ** )
[ $8A $07 ] ( mov  al,[bx] )
[ $B4 $00 ] ( mov  ah,0    )
;

: c@>bx  ( -:- => c:- )
( ** Byte von Adresse nach DX ** )
[ $8A $1F ]  ( mov bl,[bx] )
[ $30 $FF ]  ( xor dh,dh   )
;

: c@>dx  ( -:- => c:- )
( ** Byte von Adresse nach DX ** )
[ $8A $17 ]  ( mov dl,[bx] )
[ $30 $F6 ]  ( xor dh,dh   )
;

: !  ( -:n --> -:n )
     ( adr => adr )
( ** Wort in adr speichern ** )
[ $89 $07 ] ( mov  [bx],ax )
;

: dx>!  ( n:- => n:- )
        ( adr => adr )
( ** Wort aus DX-Register an adresse speichern ** )
[ $89 $17 ] ( mov [bx],dx )
;

: c!  ( -:c => -:c )
      ( adr => adr )
( ** Byte in adr speichern ** )
[ $88 $07 ] ( mov  [bx],al )
;

: dx>c!  ( c:- => c:- )
         ( adr => adr )
( ** Byte aus DX-Register an Adresse speichern ** )
[ $88 $17 ] ( mov [bx],dl )
;

: +!  ( -:n => -:n )
      ( adr => adr )
( ** Wort in adr um n erhhen ** )
[ $01 $07 ] ( add  [bx],ax )
;


: inc  ( => )
       ( adr => adr )
( ** Wort in adr um 1 erhhen ** )
[ $FF $07 ] ( inc  [bx]  )
;


: dec  ( => )
       ( adr => adr )
( ** Wort in adr um 1 erniedrigen ** )
[ $FF $0F ] ( dec  [bx]  )
;


: cmove  ( nach:u => nach:- )
         ( von => von )
( ** u Bytes im Memory verschieben ** )
( Quelle: vonadr,  Ziel: nachadr      )
( Verschieben nur im aktuellen CS !   )
( Bereich drfen berlappen !         )
( Syntax: vonadr to nachadr u cmove   )
[ $89 $CF ]   ( mov  di,cx )
[ $89 $C1 ]   ( mov  cx,ax )
[ $8C $C8 ]   ( mov  ax,cs )
[ $8E $C0 ]   ( mov  es,ax )
[ $87 $F3 ]   ( xchg si,bx )
[ $87 $FA ]   ( xchg di,dx )
[ $39 $F7 ]   ( cmp  di,si )
[ $7E 7   ]   ( jg   +7    ) 
[ $03 $F1 ]   ( add  si,cx )
[ $03 $F9 ]   ( add  di,cx )
[ $4E ]       ( dec  si    )
[ $4F ]       ( dec  di    )
[ $FD ]       ( std        )
[ $F3 $A4 ]   ( rep  movsb )
[ $FC ]       ( cld        )
[ $89 $DE ]   ( mov  si,bx )
[ $89 $D1 ]   ( mov  cx,dx )  
;

: cfill  ( c:u => ?:? )
         ( adr => adr )
( ** u Bytes ab adr mit char c fllen ** )
[ $51 ]       ( push cx        )
[ $89 $C1 ]   ( mov  cx,ax     )
[ $8C $C8 ]   ( mov  ax,cs     )
[ $8E $C0 ]   ( mov  es,ax     )
[ $89 $DF ]   ( mov  di,bx     )
[ $89 $D0 ]   ( mov  ax,dx     )
[ $F3 $AA ]   ( rep  stosb     )
[ $59 ]       ( pop  cx        )
;


: fill  ( n:u => ?:? ) 
        ( str => )
( ** u Worte ab adr mit n fllen ** )
( ** u ist maximal 32k           ** )
[ $51 ]       ( push cx        )
[ $89 $C1 ]   ( mov  cx,ax     )
[ $8C $C8 ]   ( mov  ax,cs     )
[ $8E $C0 ]   ( mov  es,ax     )
[ $89 $DF ]   ( mov  di,bx     )
[ $89 $D0 ]   ( mov  ax,dx     )
[ $F3 $AB ]   ( rep  stosw     )
[ $59 ]       ( pop  cx        )
;

: erase  ( -:u => ?:? )
         ( adr => adr )
( ** ab adr u Bytes auf 0 setzen ** )
dx 0  cfill 
;

: on  ( => )
      ( adr => adr )
( ** Wert in adr auf -1 setzen ** )
[ $C7 $07 $FF $FF ] ( mov [bx],-1 )
;

: off  ( => )
       ( adr => adr )
( ** Wert in adr auf 0 setzen ** )
[ $C7 $07 $00 $00 ] ( mov [bx],0 )
;

: blanks  (  -:u => ?:? )
          ( adr => adr )
( ** ab adr u Bytes auf 32 setzen ** )
dx bl cfill 
;


: d@  ( -:- => d )
      ( adr => adr )
( ** doppelt genaues Wort holen ** )
[ $C4 $07 ] ( les ax,[bx] )
[ $8C $C2 ] ( mov dx,es   )
;


: d!  ( d => d )
      ( adr => adr )
( ** doppelt genaues Wort speichern ** )
[ $89 $57 $02 ] ( mov [bx+2],dx )
[ $89 $07 ]     ( mov [bx],ax   )
;

: here  ( => )
        ( => adr )
( ** liefert adr des freien Speichers ** )
adr dp @>bx 
;

: pad  ( --> )
       ( => adr )
( ** Adresse von PAD holen ** )
here
[ $83 $C3 $44 ]  ( add bx,$44 )
;

: allot  ( n --> )
( ** reserviert n Bytes ab here ** )
( setzt here um n herauf )
adr dp +! 
;


: sp@  ( -:- => -:adr )
       ( => )
( ** Hole Stackpointer ** )
[ $89 $F0 ] ( mov ax,si )
;


: sp!  ( -:adr => -:adr )
       ( => )
( ** Setze Stackpointer ** )
[ $89 $C6 ] ( mov si,ax )
;


: rp@  ( -:- => -: adr )
       ( => )
( ** Hole adr Returnpointer ** )
[ $89 $E0 ] ( mov ax,sp )
;


: rp!  ( -:adr => -:adr )
       ( => )
( ** Setze Returnpointer ** )
[ $89 $C4 ] ( mov sp,ax )
;



( *** Untersttzung strukturierter Befehle *** )


: i  ( -:- => -:index )
     ( => )
( ** Schleifenindex nach AX kopieren ** )
[ $89 $C8 ] ( mov ax,cx )
;

: i>adr  ( => )
         ( => index )
( ** Schleifenindex nach BX kopieren ** )
[ $89 $CB ] ( mov bx,cx )
;

: i>dx  ( -:- => index:- )
        ( => )
( ** Schleifenindex nach DX kopieren ** )
[ $89 $CA ]  ( mov dx,cx )
;

: j  ( -:- => -:index )
     ( => )
( ** ueren Schleifenindex kopieren ** )
r
;

: j>adr  ( => )
         ( => index )
( ** ueren Schleifenindex kopieren ** )
[ $5B $53 ]  ( pop bx push bx )
;

: leave  ( => )
         ( => )
( ** Befehle bis LOOP bearbeiten ** )
( ** und dann Schleife verlassen ** )
[ $89 $CD ] ( mov bp,cx )
;

: exit  ( => )
        ( => )
( ** Wort abbrechen,                ** )
( ** wirkt wie Sprung auf Semikolon ** )
[ $C3 ] ( ret )
;



( *** Flag- und Vergleichs- operatoren *** )

: .T.   ( => ) ( true )
        ( => )
( ** Flag True ** )
[ $F9 ] ( stc )
;

: .F.   ( => ) ( false )
        ( => )
( ** Flag False ** )
[ $F8 ] ( clc )
;

: .not. ( => ) ( f )
        ( => ) 
( ** Flag Komplement ** )
[ $F5 ] ( cmc )
;

: .and.  ( => ) ( f1 f2 => f' )
         ( => )
( **   f' := f1 and f2    ** )
( ! nur in { ... } mglich ! )
[ $D1 $D7 ]  ( rcl di,1  )
[ $21 $EF ]  ( and di,bp )
[ $D1 $ED ]  ( shr bp,1  )
[ $D1 $CF ]  ( ror di,1  )
;

: .or.  ( => ) ( f1 f2 => f' )
        ( => )
( ** f' := f1 or f2 ** )
( nur in { ... } mglich ! )
[ $D1 $D7 ]  ( rcl di,1  )
[ $09 $EF ]  ( or  di,bp )
[ $D1 $ED ]  ( shr bp,1  )
[ $D1 $CF ]  ( ror di,1  )
;

: .xor.  ( => ) ( f1 f2 => f' )
         ( => )
( ** f' := f1 xor f2 ** )
( nur in { ... } mglich ! )
[ $D1 $D7 ]  ( rcl di,1  )
[ $31 $EF ]  ( xor di,bp )
[ $D1 $ED ]  ( shr bp,1  )
[ $D1 $CF ]  ( ror di,1  )
;

: .odd.  ( -:n ) ( f )
( ** f := .T. wenn n ungerade ** )
[ $D1 $D8 ] ( rcr ax,1 )
[ $D1 $D0 ] ( rcl ax,1 )
;

: .even.  ( -:n ) ( f )
( ** f := .T. wenn n gerade ** )
.odd. .not.
; 

: .0=.  ( -:n => -:n ) ( f )
        ( => )
( ** f:=.T. if n=0 ** )
[ $3D 0 0 ] ( test ax,ax )
[ $75 1 ]   ( jnz  +1    )
[ $F5 ]     ( cmc        )
;

: .1=.  ( -:n => -:n ) ( f )
      ( => )
( ** f:=.T. if n=1 ** )
[ $3D 1 0 ] ( cmp  ax,1  )
[ $F8 ]     ( clc        )
[ $75 1 ]   ( jnz  +1    )
[ $F5 ]     ( cmc        )
;


: .-1=.  ( -:n => -:n ) ( f )
       ( => )
( ** f:=.T. if n=-1 ** )
[ $3D $FF $FF ] ( cmp  ax,-1  )
[ $F8 ]     ( clc        )
[ $75 1 ]   ( jnz  +1    )
[ $F5 ]     ( cmc        )
;


: .0<.  ( -:n => -:n ) ( f )
        ( => )
( ** f:=.T. if n<0 ** )
[ $3D 0 0 ] ( cmp  ax,0  )
[ $F8 ]     ( clc        )
[ $7D 1 ]   ( jge  +1    )
[ $F5 ]     ( cmc        )
;


: .0>.  ( -:n => -:n ) ( f )
        ( => )
( ** f:=.T. if n>0 ** )
[ $3D 0 0 ] ( cmp  ax,0  )
[ $F8 ]     ( clc        )
[ $7E 1 ]   ( jle  +1    )
[ $F5 ]     ( cmc        )
;

  
: .0<>.  ( -:n => -:n ) ( f )
         ( => ) 
( ** f=.T. if n <> 0 ** )
.0=. .not. [ $F5 ] ( cmc )
;

: .=.   ( n1:n2 => n1:n2 ) ( f )
        ( => )
( ** f:=.T. if n1 = n2 ** )
[ $39 $D0 ] ( cmp  ax,dx )
[ $F8 ]     ( clc        )
[ $75 1 ]   ( jnz  +1    )
[ $F5 ]     ( cmc        )
;

: .>.  ( n1:n => n1:n ) ( f )
       ( => )
( ** f=.T. if n > n1 ** )
[ $39 $C2 ]  ( cmp dx,ax )
[ $F8 ]      ( clc       )
[ $7D $01 ]  ( jge +1    )
[ $F5 ]      ( cmc       )
;


: .<.  ( n1:n => n1:n ) ( f )
       ( => )
( ** f=.T. if n < n1 ** )
[ $39 $C2 ]  ( cmp dx,ax )
[ $F8 ]      ( clc       )
[ $7E $01 ]  ( jle +1    )
[ $F5 ]      ( cmc       ) 
;

: .<>.  ( n1:n2 => n1:n2 ) ( f )
        ( => )
( ** f=-1 if n1 <> n2 ** )
.=. .not.
;


: .u>.  ( um:u ) ( f ) 
        ( => )
( ** f= .T. if u > um  ** )
[ $39 $C2 ]     ( cmp  dx,ax )
;

: .u<.  ( um:u ) ( f ) 
        ( => )
( ** f= .T. if u < um ** )
[ $39 $D0 ]     ( cmp  dx,ax )
;

: .>?<.   ( no:n => no:n ) ( f )
          ( nu => nu )
( ** f=.T. if nu <= n <= no ** )
[ $31 $FF ]  (     xor di,di )
[ $39 $D0 ]  (     cmp ax,dx )
[ $77 $05 ]  (     ja  ex    )
[ $39 $D8 ]  (     cmp ax,bx )
[ $72 $01 ]  (     jb  ex    )
[ $47 ]      (     inc di    )
[ $D1 $DF ]  ( ex: rcr di,1  )
;

: .d0=.  ( d => d ) ( f )
         ( => )
( ** f := .T. wenn d gleich Null ** )
[ $89 $D7 ]  ( mov di,dx )
[ $09 $C7 ]  ( or  di,ax )
[ $F8 ]      ( clc       )
[ $75 $01 ]  ( jnz +1    )
[ $F9 ]      ( stc       )
;





( *** Funktionen *** )

: abs  ( -:n --> -:n' )
       ( => )
( ** n':= Absolutwert ** )
[ $3D 0 0 ]  ( cmp ax,0 )
[ $7d 2   ]  ( jge +2   )
[ $F7 $D8 ]  ( minus ax )
;

: dabs ( d => d' )
       ( => )
( ** d' := Absolutwert ** )
[ $80 $C6 $00 ]   ( add dh,00  )
[ $79 $0A ]       ( jns ex     )
[ $F7 $D0 ]       ( not ax     )
[ $F7 $D2 ]       ( not dx     )
[ $05 $01 $00 ]   ( add ax,1   )
[ $83 $D2 $00 ]   ( adc dx,0   )
;


: shr  ( i:n => ?:n')
       ( => )
( ** Shift n rechts um i Stellen ** )
[ $89 $CF ] ( mov di,cx )
[ $89 $D1 ] ( mov cx,dx )
[ $D3 $E8 ] ( shr ax,cl )
[ $89 $F9 ] ( mov cx,di )
;

: shl  ( i:n => ?:n')
       ( => )
( ** Shift n links um i Stellen ** )
[ $89 $CF ] ( mov di,cx )
[ $89 $D1 ] ( mov cx,dx )
[ $D3 $E0 ] ( shl ax,cl )
[ $89 $F9 ] ( mov cx,di )
;

: .d>n.  ( d => d )( f )
         ( => )
( ** Doppelzahl in einfache mit Vorzeichen  ** )
( f:=.F. wenn Bereich einf. Zahl berschritten )
dpush
{ pushf .0<.  xchg       ( ax kleiner 0 ? )
  pushf .-1=. .and.      ( and dx = -1 ?  )
  pushf .0=.  xchg       ( oder dx = 0 ?  )
  pushf .0<. .not. .and. ( and ax nicht negativ? ) 
  .or. }
  if dpop .T.
  else dpop .F.
  endif
  ;
  
: .d>u.  ( d => d )( f )
         ( => )
( ** Doppelzahl in einfache ohne Vorzeichen ** )
( f:=.F. wenn Bereich einf. Zahl berschritten )
xchg .0=. xchg   ( dx = 0 ?  )
;



( *** einfache Ein-/Ausgabe *** )

: port!  ( adr:n )
( ** gib n an Portadresse aus ** )
[ $EF ]     ( out dx,ax )
;

: port@  ( adr:- => adr:n )
( ** Hole Wort vom Port ** )
[ $ED ]     ( in  ax,dx )
;

: portc!   ( adr:c )
( **  Gib Byte an portadr aus  ** )
[ $EE ]    ( out dx,al )
;

: portc@ ( adr:- => adr:c )
( **  Hole Byte von portadr  ** )
[ $EC ]           ( in al,dx  )
[ $B4 $00 ]       ( mov ah,0  )
;


( ** Weitere Funktionen ** )

: combine   ( c1:c2 => -:n )
( ** Kombiniere 2 Bytes zu einem Wort ** )
( c2:= lower Byte, c1:= higher Byte in n )
[ $88 $D4 ]  ( mov ah,dl )  
; 

: split     ( -:n => c1:c2 )
( **   Teile Wort in 2 Bytes     ** )
( c2:= lower Byte, c1:= higher Byte )
[ $88 $E2 ]  ( mov dl,ah )
[ $30 $F6 ]  ( xor dh,dh )
[ $88 $F4 ]  ( mov ah,dh )
;
  
: even   ( --> )
( ** setze HERE auf gerade Adresse ** )
here 
[ $D1 $DB ] ( rcr bx,1 )
if 1 allot endif 
;

: para   ( --> )
( ** setze HERE auf Paragraphen ** )
here bx>
15 and dx 16
.0<>. if xchg - allot endif 
;           

( ** Bitsteuerung: ** )

: 2^n  ( -:n => -:2^n )
( **    2 hoch n    ** )
( **  0 <= n <= 15  ** )
[ $89 $CF ]   ( mov  di,cx )
[ $89 $C1 ]   ( mov  cx,ax )
[ $B8 1 0 ]   ( mov  ax,1  )
[ $D3 $E0 ]   ( shl  ax,cl )
[ $89 $F9 ]   ( mov  cx,di )
;

: clrbit ( pos:n => -:n )
( **  Setze Bit an pos auf 0  ** )
( **      0 <= pos <= 15      ** )
xchg 2^n not and 
;

: setbit ( pos:n => -:n )
( **  Setze Bit an pos auf 1  ** )
( **     0 <= pos <= 15       ** )
xchg 2^n or 
;

: getbit ( pos:n => -:1|0 )
( **  Hole Bitwert von pos ** )
( **     0 <= pos <= 15    ** )
[ $89 $CF ]   ( mov  di,cx   )
[ $89 $D1 ]   ( mov  cx,dx   )
[ $D3 $E8 ]   ( shr  ax,cl   )
[ $89 $F9 ]   ( mov  cx,di   )
[ $25 1 0 ]   ( and  ax,0001 ) 
;

: log2    ( 2^n --> n )
( **  Integer[log2[n]]  ** )
( **    0 <= n <= 15    ** )
  [ $BB $FF $FF ]  (     BX, #-1 MOV )
  [ $43 ]          ( $1: BX INC      )
  [ $D1 $E8 ]      (     AX, 1 SHR   )
  [ $75 $FB ]      (     JNZ $1      )
  [ $8B $C3 ]      (     AX, BX MOV  )
;


( ** Interruptsteuerung ** )
( ** MS-DOS und intr    ** )


: intr  ( n --> )
  ( Interrupt aufrufen )
  [ $C6 $06 $2E $01 $00 ] ( mov [12E],00 ) ( Fehlerflag lschen )
  [ $E8 0 0 ]             ( call next pc )
  [ $5B ]                 ( pop bx )
  [ $83 $C3 $2B ]         ( add bx,$2B )
  c!                      ( Interrupt patchen )
  r.ax  bx>               ( Adresse variable AX --> ax )
  ( push Register auf Returnstack )
  [ $9C $06 $1E $57 $56 $55 $52 $51 $53 $50 ] 
  (  FL  ES  DS  DI  SI  BP  DX  CX  BX  AX )
  [ $FA ]                 ( cli             )
  [ $94 ]                 ( xchg ax,sp      )
  [ $A3 $2A $01 ]         ( mov  [12A],ax   )
  ( pop Register von User )
  [ $58 $5B $59 $5A $5D $5E $5F $1F $07 $9D ]
  (  AX  BX  CX  DX  BP  SI  DI  DS  ES  FL )
  [ $2E $87 $26 $2A $01 ] ( xchg cs:[12A],sp   )
  [ $FB ]                 ( sti             )
  [ $CD $00 ]             ( gepatchten Interrupt ausfhren )
  [ $FA ]                 ( cli       )
  [ $0E ]                 ( push cs   )
  [ $17 ]                 ( pop  ss   )
  [ $2E $87 $26 $2A $01 ] ( xchg sp,cs:[12A] )
      ( push Register nach User )
  [ $9C $06 $1E $57 $56 $55 $52 $51 $53 $50 ] 
   ( FL  ES  DS  DI  SI  BP  DX  CX  BX  AX )
  [ $2E $8B $26 $2A $01 ] ( mov  sp,cs:[12A] )
  [ $FB ]                 ( set interrupt )
      ( pop Register von Returnstack )
  [ $58 $5B $59 $5A $5D $5E $5F $1F $07 ]
   ( AX  BX  CX  DX  BP  SI  DI  DS  ES )
  [ $73 $04 ]             ( jnc +4 )
  [ $FE $0E $2E $01 ]     ( dec b/[12E] ) ( Fehlerbyte setzen )
  [ $9D ]                 ( pop flags  )
;


: msdos ( n --> )
  ( Interrupt $21, Funktion n aufrufen )
  dosfkt c!           ( zur Analyse nach dosfkt ) 
  r.ax bx+ c!        ( und nach AH )
  $21 intr            ( Interrupt aufrufen )
;


: ?msdos ( n --> )
( * Interrupt $21, Funktion n aufrufen               * )
( * Wenn ein Fehler auftrat, wird doserr aufgerufen  * )
  msdos 
  adr dosflag 
  c@if            ( Fehler aufgetreten )
    r.ax c@       ( rufe doserr mit    )
    doserr        ( Fehlernummer auf   )
  endif
;


: cs@ ( -:- => -:segadr )
( ** Codesegment holen ** )
  [ $8C $C8 ]    ( mov ax,cs     )
;


: getint  ( -:n => offs:seg )
( ** Interruptvektor n holen ** )
   r.ax ! $35 msdos r.bx @ r.es @>dx
;

: setint  ( seg:offs => )
          ( => )
          ( n => )
( ** Interruptvector n setzen ** )
   r.dx ! r.ds dx>! pop r.ax ! $25 msdos
;

( **  Zeichen-Ein- und Ausgabe ** )


proc read ( handle:count => -:count' ) ( f )
          ( adr => )
( **    Zeichen aus Datei lesen       ** ) 
( ** Wenn Handlefehler, Doserr rufen  ** )
( **    f = 0 wenn erfolgreich        ** )
( ** f=.F. wenn weniger Zeichen (EOF) ** )
( ** AX enthlt Zahl gelesene Zeichen ** )
  [ $89 $CF ]  ( mov  di,cx )   ( cx retten )
  [ $89 $C1 ]  ( mov  cx,ax )   ( count )
  [ $52 ]      ( push dx    )   ( handle retten )
  [ $89 $DA ]  ( mov  dx,bx )   ( Bufadr )
  $3F dosfkt c!
  [ $5B ]      ( pop  bx    )   ( Handle )
  [ $B4 $3F ]  ( mov  ah,3F )   ( read )
  [ $CD $21 ]  ( int  21    )
  [ $87 $CF ]  ( xchg cx,di )   ( cx restaur. )
  [ $72 $03 ]  ( jc   03    )   ( Fehler )
  [ $39 $F8 ]  ( cmp  ax,di )   ( Flag setzen )
  [ $C3 ]      ( ret        )
  doserr
;


proc write ( handle:count => -:count' )
           ( adr => )
( **      Zeichen in Datei schreiben      ** ) 
( **   Wenn Handlefehler, Doserr rufen    ** )
( **  Wenn weniger Zeichen, Doserr rufen  ** )
( ** AX enthlt Zahl geschriebene Zeichen ** )
  [ $89 $CF ]     ( mov  di,cx ) ( cx retten )
  [ $89 $C1 ]     ( mov  cx,ax ) ( count )
  [ $52 ]         ( push dx    ) ( handle retten )
  [ $89 $DA ]     ( mov  dx,bx ) ( Bufadr )
  $40 dosfkt c!
  [ $5B ]         ( pop  bx    ) ( Handle )
  [ $B4 $40 ]     ( mov  ah,40 ) ( write )
  [ $CD $21 ]     ( int  21    )
  [ $87 $CF ]     ( xchg cx,di ) ( cx restaur. )
  [ $72 $08 ]     ( jc   doser ) ( Fehler )
  [ $39 $F8 ]     ( cmp  ax,di ) 
  [ $75 $01 ]     ( jc   01    ) ( Platte voll )
  [ $C3 ]         ( ret        ) 
  [ $B8 $FE $FF ] ( mov  ax,-2 )
  doserr
;

: >con  ( --> )
( ** Ausgabe an CONSOLE ** )
( ** - umleitbar -      ** )
1 #stdout !
;

: >prn  ( --> )
( ** Ausgabe an PRINTER  ** )
( ** - nicht umleitbar - ** )
4 #stdout !
;

: >aux  ( --> )
( ** Ausgabe an RS232    ** )
( ** - nicht umleitbar - ** )
3 #stdout !
;

: >file   ( --> )
( ** Ausgabe auf handle #fout umleiten ** )
#fout @ #stdout ! 
;

: errdev  ( --> )
( ** Ausgabe an Schirm          ** )
( ** - nicht umleitbar -        ** )
( ** laufendes Handle speichern ** )
#stdout @ #hold !  2 #stdout !
;

: -errdev  ( --> )
( ** Ausgabe an voriges Handle ** )
#hold @ #stdout !
;

proc (emit)  ( -:c => ?:- )
( ** Zeichen in laufendes Handle ausgeben ** )
   double c!
#stdout @>dx 1  double  write 
;

proc (type)  ( -:count => -:? )
             ( adr => adr )
( ** String an Handle senden ** )
bx>tx #stdout @>dx tx>bx write 
;

: count  ( -:- => -:n )
         ( adr => adr+1 )
( ** n := Stringlnge ** )
c@    ( Count-Byte holen )
bx+   ( Adresse erhhen  )
;


: space  ( => )
( ** Leerzeichen ausgeben ** )
dpush
bl emit
dpop
;


: spaces  ( n => )
( ** n Leerzeichen ausgeben ** )
, 1 do space loop
;

: cr  ( => )
( ** CRLF ausgeben ** )
dpush
(crlf) 2 type
dpop
;

proc (key)  ( => ?:c )
( ** Tastatureingabe --> TOS ** )
( ** Sondertasten 256 erhht ** )
0 r.ax ! $16 intr
r.ax @  
[ $3C $00 ]      ( cmp al,0   )
[ $74 $03 ]      ( jz ew      )
[ $30 $E4 ]      ( xor ah,ah  )
[ $C3 ]          ( ret        )
[ $86 $C4 ]      ( xchg al,ah )
[ $05 $FF $00 ]  ( add ax,256 )
;

proc .?key.  ( => ) ( f )
( ** f:=1 : Zeichen vorhanden ** )
[ $B4 $0B ] ( mov ah,$B )
[ $CD $21 ] ( int 21h   )
[ $3C $01 ] ( cmp al,1  ) 
;

: wait     ( --> )
( **  Warte auf Taste mit Nachricht  ** )
errdev
."  -Mit jeder Taste weiter..!" 
key -errdev
;

proc (expect)  ( -:count => -:- )
               ( adr => adr )
( ** String von Keybord erwarten ** )
( ** und bei adr ablegen         ** )
bx-           ( Eingabelnge setzen )
[ $88 $07 ]   ( mov [bx],al )
[ $89 $DA ]   ( mov dx,bx )
[ $B4 $0A ]   ( mov ah,10 )
[ $CD $21 ]   ( int 21h   )
bx+ 
;

: >default  ( -:- = -:1 )
( ** Ausgabe an Console ** )
     1 #stdout !  
     make emit   (emit)
     make type   (type)
     make key    (key)
     make ?key   .?key.
     make expect (expect)
;



( *** formatierte Ausgabe *** )


: <#  ( d => -:- )
      ( => )
      ( => d )
( ** Start formatierte Ausgabe ** )
dpush
pad bx> hld !  ( Zeiger hld auf Scratchpad setzen )
;

: hold  ( -:c => -:c )
        ( => ? )
( ** Zeichen an Adresse in hld speichern ** )
hld dec    ( hld dekrementieren )
@>bx c!    ( Zeichen ablegen    )
;


: #  ( -:- => ?:? )
     ( => ? )
     ( ud => ud' )
( ** eine Ziffer ablegen ** )
dload 
.d0=. .not.            ( auf Null prfen )
  if
    base c@>bx         ( Basis nach RX )
    [ $89 $1C ]        ( mov [si],bx )
    d/                 ( Ziffer berechnen )
    [ $8B $1C ]        ( mov bx,[si] )
    dstore             ( Restzahl ablegen )
    bx> dx '0' +       ( in ASCII-Format bringen )
    dx '9' .>.         ( Zahlenbasis grer 10 ? )
    if dx 7 + endif    ( ja, dann Korrektur )
  else
    pad bx>dx
    hld @ .=.          ( letzte Stelle? )
    if                 ( ja, dann '0' ausgeben )
      '0'
    else               ( sonst )
      leading @        ( Leerzeichen oder Null ausgeben )
    endif
  endif
hold                   ( Ziffer ablegen )
;


: #s  ( ud --> ud' )
( ** restliche Ziffern ablegen ** )
  begin
    dload .d0=.  ( Solange Zahl ungleich Null ... )
    .not.
  while
    #            ( ... Ziffer ausgeben )
  repeat
;


: #>  ( ud --> adr n )
      ( => adr )
( ** Ende formatierte Ausgabe, Zahl ist type-fertig ** )
  2drop             ( Zahl entfernen )
  pad bx>dx hld @   ( Adressen holen )
  >bx - abs         ( Count-Byte erzeugen )
;


: sign  ( => ) 
        ( => )
        ( d --> d )
( ** Vorzeichen in formatierte Ausgabe .. ** )
( einfgen, wenn n negativ ist. Byte in ES.  )
  tx>     ( Vorzeichen-Byte holen )
  [ $D1 $E0 ] ( sal ax,1 ) ( Vorzeichen negativ ? )
  if
    '-'   ( ja, dann Minuszeichen )
  else
    bl    ( nein, dann Leerzeichen )
  endif
  hold    ( Zeichen ausgeben )
;


: d.  ( d => ? )
      ( => )
  ( doppelt genaue Zahl ausgeben )
  [ $8E $C2 ]  ( mov es,dx ) ( Vorzeichen )
  dabs         ( Absolutwert bilden )
  <# # #s      ( Zahl ausgeben )
  sign #>      ( Vorzeichen anfgen )
  type         ( ... und drucken )
;


: d.r  ( d => ? )
       ( u => ? )
( ** doppelt genaue Zahl in u Stellen ausgeben ** )
  bx>r           ( Feldbreite merken )
  [ $8E $C2 ]    ( mov es,dx ) ( Vorzeichen )
  dabs           ( Absolutwert bilden )
  <#             ( Start Ausgabe )
  r>             ( Feldbreite holen )  
  , 1 do # loop  ( Ausgabe entsprechend Feldbreite )
  sign #>        ( Vorzeichen anfgen )
  type           ( ... und drucken )
;


: .  ( -:n => ?:? )
     ( => )
( ** einfach genaue Zahl ausgeben ** )
  n>d   ( in doppelt genaue Zahl konvertieren )
  d.     ( ... und ausgeben )
;


: .r  ( u:n => ?:? )
      ( => )
( ** einfach genaue Zahl in u Stellen ausgeben ** )
  dx>bx n>d   ( in doppelt genaue Zahl konvertieren )
  d.r         ( ... und ausgeben )
;


: u.  ( -:u => ?:? )
      ( => )
( ** vorzeichenlose Zahl ausgeben ** )
dx 0       ( auf doppelte Genauigkeit erweitern )
<# # #s #> ( Konvertierung ohne Vorzeichen )
type       ( ... und ausgeben )
;


: u.r  ( u1:u => ?:? )
       ( => ? )
( ** vorzeichenlose Zahl in u1 Stellen ausgeben ** )
dx>r        ( Feldbreite retten )
dx 0        ( auf doppelte Genauigkeit erweitern )
<#          ( Start Ausgabe )
r> , 1      ( Schleifenzhler )
do # loop ( Ausgabe entsprechend Feldbreite )
#> type     ( ... und drucken )
;


: nib.h  ( -:n => -:? )
( ** Gib unteres Nibble als Hex aus  ** )
( Trick conversion aus DOS-UNDOCUMENTED )
( Schulman: Addison-Wesley 1991         )              
[ $24 $0F ]  ( and al,0F )
[ $04 $90 ]  ( add al,90 )
[ $27 ]      ( daa       )
[ $14 $40 ]  ( adc al,40 )
[ $27 ]      ( daa       )
emit
;

: byte.h  ( -:n => )
( ** Gib unteres Byte in Hex aus ** )
( push cx )
>tx    ( ax retten )
dx 4 shr nib.h
tx> nib.h 32 emit
;

: u.h  ( -:u => -:? )
( ** Gib Wort als Hexzahl aus ** )
>tx dx 12 shr nib.h
tx> dx  8 shr nib.h
tx> dx  4 shr nib.h
tx> nib.h 32 emit
;

: bit.b  ( pos:n => ?:? )
( ** Gib Bit in pos aus ** )
  getbit dx $30 + emit 
;

: u.b  ( u --> )
( ** Gib u als Binrzahl aus ** )
push
, 15 12 do  i>dx 1load bit.b 1 -loop space
, 11  8 do  i>dx 1load bit.b 1 -loop space
,  7  4 do  i>dx 1load bit.b 1 -loop space
,  3  0 do  i>dx 1load bit.b 1 -loop space
pop
;



( *** verschiedene Funktionen *** )

: hex  ( => )
       ( => ? )
( ** Zahlenbasis 16 setzen ** )
[ $89 $C7 ] ( mov di,ax )
16 base !
[ $89 $F8 ] ( mov ax,di )
;


: decimal  ( => )
           ( => ? )
( ** Zahlenbasis 10 setzen ** )
[ $89 $C7 ] ( mov di,ax )
10 base !
[ $89 $F8 ] ( mov ax,di )
;

: .hexdigit.  ( -:c => -:n ) ( f )
              ( => )
( ** Convert Hex Digit in Zahl   ** )
( c := Digit, n := Zahl             )
( f:=.T. wenn c Hexdigit,klein|gro )
[ $2C $30 ]  ( sub al,30 )
[ $72 $10 ]  ( jc ex     )
[ $3C $0A ]  ( cmp al,0A )
[ $F5 ]      ( cmc       )
[ $73 $0B ]  ( jnc ex    )
[ $24 $5F ]  ( and al,5F )
[ $2C $07 ]  ( sub al,07 )
[ $3C $0A ]  ( cmp al,0A )
[ $72 $03 ]  ( jc ex     )
[ $3C $10 ]  ( cmp al,10 )
[ $F5 ]      ( cmc       )
[ $F5 ]      ( ex: cmc   )
;

: .decdigit.  ( -:c => -:n ) ( f )
              ( => )
( ** Konvertiere Dec-Ziffer in Zahl ** )
( f := .T. wenn c Decimalziffer        )
[ $2C $30 ]  ( sub al,30 )
[ $72 $05 ]  ( jc ex     )
[ $3C $0A ]  ( cmp al,0A )
[ $73 $02 ]  ( jnc ex+1  )
[ $F5 ]      ( cmc       )
[ $F5 ]      ( ex: cmc   )
;

proc .digit.  ( -:c => -:n ) ( f )
              ( => )
( ** Zeichen in Zahl konvertieren ** )
( c ist ein nach dem Zahlensystem gltiges Zeichen )
( f := .T. wenn c gltig )
   dx '0' -
   dx 16 .>.
   if
     dx 7 -
   endif
   dx 41 .>.
   if
     dx 32 -
   endif
   { base c@>dx .<. pushf .0<. .not. .and. }
   if
    .T. else .F.
   endif
;

: (number)  ( ?:? => ?:? )
            ( => ? )
            ( d => d' )
( ** wandelt solange um, bis ungltiges Zeichen kommt ** )
( Startadresse in BP erwartet!                     )
  begin
    [ $89 $EB ]     ( mov bx,bp )
    c@  .digit.     ( Zeichen holen und prfen )
    in dec          ( Eingabe-Zhler dekrementieren )
  while             ( solange Ziffer )
    >tx dload
    base @>bx 
    bxpush
    du*             ( Word mit Base multiplizieren )
    dstore 
    tx> 0>dx d+     ( Ziffer aufaddieren )
    [ $45 ]         ( inc bp ) ( nchste Adresse )
  repeat
;

var (base) [ 0 , ]  ;

: number  (  --> d )
          ( str => )
( ** String in doppeltgenaue Zahl konvertieren ** )
(      Nachkommastellen sind in dpl abgelegt      )
  [ $55 ]          ( push bp )
  c@ 1+ bx+        ( count holen )
  [ $89 $DD ]      ( mov bp,bx )
  in !             ( count speichern )
  base @ (base) !  ( Zahlenbasis retten )
  [ $89 $EB ]      ( mov bx,bp )
  c@               ( 1.Zeichen )
  dx '-' .=.       ( negative Zahl ? )
  >r               ( merken )
  if [ $45 ]       ( inc bp )
    in dec endif   ( Minuszeichen berlesen )
  dx '$' .=.
  if [ $45 ]       ( inc bp )
    in dec
    hex endif      ( Hex-Zahl! )
  0 push push      ( 2 Nullen auf Stack )
  dpl !            ( Dezimalpunkt lschen )
  (number)         ( konvertieren )
  [ $89 $EB ]      ( mov bx,bp )
  c@               ( Zeichen holen )
  dx '.' .=.       ( Dezimalpunkt ? )
  if
    in @ 1- dpl !  ( Position merken )
    [ $45 ]        ( nchste Adresse )
    (number)       ( weiter konvertieren )
  endif 
  (base) @ base !  ( Basis wiedereinsetzen )
  dpop 
  r>bx             ( Vorzeichen holen )
  [ $83 $FB $2D ]  ( cmp bx,'-' )
  [ $F8 ]          ( clc )
  [ $75 $01 ]      ( jne +1 )
  [ $F5 ]          ( cmc )
   if dminus endif ( evtl. Vorzeichenwechsel )
  [ $5D ]          ( pop bp )
;

seal (base)

: .number. ( => d )( f )  ( doppelt genaue Zahl )
           ( str => )  
( ** String in Zahl wandeln, mit Fehlerflag  ** )
( in dpl steht die Zahl der Nachkommastellen    )
  
  number dpush
  in  @ .0=.
  if   .T.
  else .F.
  endif dpop 
;

: min  ( n1:n2 => n1:min )
( ** Minimum der Zahlen ** )
  .>.
  if xchg endif
;

: umin  ( u1:u2 => u1:min )
( ** Minimum der vorzeichenlosen Zahlen** )
  .u>.
  if xchg endif
;


: max  ( n1:n2 --> ?:max )
( ** Maximum der Zahlen ** )
  .<.
  if xchg endif
;


: umax  ( u1:u2 => ?:max )
( ** Maximum der vorzeichenlosen Zahlen ** )
  .u<.
  if xchg endif
;




( *** Initialisierung und Fehlerbehandlung *** )


: exno!  ( c => ) ( => )
( ** c wird an Vaterprogramm gegeben ** )
  adr exno c!
;

: halt  ( n --> )
( ** Programmabbruch ** )
( ** n = 0 mit cls   ** )
 if adr ex&hop else adr ex&cls endif
 [ $FF $E3 ]    ( jmp bx )
;

 
: halt"  ( n --> )
  ( Programmabbruch mit Meldung )
  ( n = 0 mit cls               )
  make type (type)
  errdev
  cr ." Programmabbruch" cr wait
  halt
;

( ** Fehlermeldungen MSDOS ** )

(long)
: dosmsg  ( n --> )
( ** DOS Fehlermeldungen ** )
     case
     -3 of  ." : Division durch Null....." ;;
     -2 of  ." : Datentrger voll........" ;;
     -1 of  ." : Dateiende erreicht......" ;;
     02 of  ." : Datei nicht gefunden...." ;;
     03 of  ." : Pfad nicht gefunden....." ;;
     04 of  ." : Zuviele Dateien geffnet" ;;
     05 of  ." : Zugriff verweigert......" ;;
     06 of  ." : Ungltige Dateinummer..." ;;
     11 of  ." : Ungltiges Format......." ;;
     12 of  ." : Ungltiger Zugriffscode." ;;
     13 of  ." : Ungltige Daten........." ;;
     15 of  ." : Ungltiges Laufwerk....." ;;
     17 of  ." : Nicht das gleiche Gert." ;;
     18 of  ." : Keine weiteren Dateien.." ;;
    $50 of  ." : Datei bereits vorhanden." ;;
     else   >dx dosfkt c@ ." DOS-Funktion " byte.h
            ." (h) - Fehler " dx> byte.h ." (h)" 
     endcase 
;
(short)


proc (doserrex)  ( n --> )
( ** Behandlung von Laufzeit-Fehlern ** )
( ** mit Programmabbruch             ** )
( ** n := DOS-Fehlernummer           ** )
  >r make emit (emit)
  make type (type)
  errdev 7 emit
  decimal r> dosmsg  
  0 halt"
;

proc (int0)  ( --> )
( ** Division durch Null ** )
( Programmabbruch     )
  -3 dosmsg  
  129 halt"
;

proc (breakex)
( ** Break-Handler fr ^C mit EXIT ** )
  make type (type)
  errdev
  cr ." ** USER BREAK" cr
  128 halt"
;

proc (break)  ( => )
( ** Setze Flag bei cs:12F ** )
[ $2E $C6 6 $2F 1 $FF ] ( mov cs:[12F],-1 )
[ $CF ]                 ( iret            )
;

: break?  ( => )( f )
( ** f := -1 bei breaktaste ** )
[ $2E $A0 $2F 1 ]     ( mov al,cs:[12F] )
[ $98 ]               ( cbw             )
[ $2E $C6 6 $2F 1 0 ] ( mov cs:[12F],0  )
;

: setbreak ( => )
( ** Leite Break-routine ber Flag ** )
   make break (break)
;


: codesegs   ( => n )
( ** n := Anzahl Paragraphen ** )
  adr r0 @ dx 4 shr     ( Segmentgre )
  .0=.
  if
    $FFF    ( Korrektur, falls Null )
  endif
  1+
;

: memrelease  ( -:- => -:? )
              ( => ? )
( ** Gib Memory oberhalb von r0 an DOS zurck ** )
  codesegs r.bx ! cs@ r.es !
  $4A ?msdos     ( Segmentgre ndern )
;

: iret ( => )
( register restore, Interrupt Return )
[ $A1 $10 $01 ]     ( mov ax,[$110] ) 
[ $8B $0E $12 $01 ] ( mov cx,[$112] )
[ $8B $16 $14 $01 ] ( mov dx,[$114] ) 
[ $8B $1E $16 $01 ] ( mov bx,[$116] )
[ $8B $2E $1A $01 ] ( mov bp,[$11A] ) 
[ $8B $36 $1C $01 ] ( mov si,[$11C] )
[ $8B $3E $1E $01 ] ( mov di,[$11E] ) 
[ $8E $06 $24 $01 ] ( mov es,[$124] )
[ $FA ]             ( cli )
[ $8B $26 $18 $01 ] ( mov sp,[$118] ) 
[ $8E $16 $26 $01 ] ( mov ss,[$126] )
[ $8E $1E $22 $01 ] ( mov ds,[$122] ) 
[ $FB ]             ( sti )
[ $CF ]             ( iret ) 
;

: resident (  -- ) ( -- )
( ** Exit and stay resident ** )
codesegs
[ $89 $C2 ]      ( mov dx,ax   )  
[ $B8 $00 $31 ]  ( mov ax,3100 )
[ $CD $21 ]      ( int 21      )
;


: initint  ( -:- => -:? )
           ( => ? ) 
( ** Setze Interrupt-Vectoren ** )
  make doserr (doserrex)
  make break (breakex)
  make int0 (int0)  
  sx $23 cs@ >dx  ( Segment )
  ax break        ( Break-vec )
  setint 
  sx 0 cs@ >dx    ( Segment )
  ax int0         ( Int0-vec  )
  setint
;

: init  ( => )
( ** Initialisieren ** )
  >default initint
;
  
dictionary

: main
  >default  ." Hallo NAXOS-Kern" wait   
;