( Wrterbuch mem.fth  )

( *********************** )
( ***** MEMORY.FTH: ***** )
( *********************** )

include string

( ** Memory-Heap-Verwaltung ** )
var FarBase  fptr ;
var FarPtr   fptr ;
var FarSize  word ;


( ***** elementare Pointer-Funktionen ***** )

: ^norm  ( => )
         ( ptr => ptr )
( ** Pointer normalisieren ** )
  [ $51 ]           ( push cx        )
  [ $C4 $2F ]       ( les  bp,[bx]   )
  [ $8C $C2 ]       ( mov  dx,es     )
  [ $89 $E9 ]       ( mov  cx,bp     )
  [ $81 $E1 $0F 0 ] ( and  cx,15     )
  [ $D1 $ED ]       ( shr  bp,1      )
  [ $D1 $ED ]       ( shr  bp,1      )
  [ $D1 $ED ]       ( shr  bp,1      )
  [ $D1 $ED ]       ( shr  bp,1      )
  [ $01 $EA ]       ( add  dx,bp     )
  [ $89 $57 2 ]     ( mov  [bx+2],dx )
  [ $89 $0F ]       ( mov  [bx],cx   )
  [ $59 ]           ( pop  cx        )
;


: ^@  ( -:- => -:n )
      ( ptr => )
( ** Wort ber Pointer holen ** )
  [ $C4 $1F ]     ( les bx,[bx]    )
  [ $26 $8B $07 ] ( mov ax,[es:bx] )
;

: ~@ ( seg:offs => -:n )
     ( => )
( ** Wort ber lange Adresse holen ** )
  [ $8E $C2 ]     ( mov es,dx      )
  [ $89 $C3 ]     ( mov bx,ax      )
  [ $26 $8B $07 ] ( mov ax,[es:bx] )  
;

: ^c@ ( -:- => -:c )
      ( ptr => ptr )
( ** Byte ber Pointer holen ** )
  [ $C4 $1F ]       ( les bx,[bx]    )
  [ $26 $8A $07 ]   ( mov al,es:[bx] )
  [ $B4 $00 ]       ( mov ah,0       )
;

: ~c@  ( seg:offs => -:c )
( ** Byte ber lange Adresse holen ** )
  [ $8E $C2 ]     ( mov es,dx      )
  [ $89 $C3 ]     ( mov bx,ax      )
  [ $26 $8A $07 ] ( mov al,[es:bx] )
  [ $B4 $00 ]     ( mov ah,0       )
;

: ^d@  ( -:- =>  d )
       ( ptr -- )
( ** Doppelwort ber Pointer holen  ** )
  [ $C4 $1F ]       ( les bx,[bx]      )
  [ $26 $8B $07 ]   ( mov ax,[es:bx]   )
  [ $26 $8B $57 2 ] ( mov dx,[es:bx+2] )
;

: ~d@ ( seg:offs => d )
( ** Doppelwort ber lange Adresse holen ** )
  [ $8E $C2 ]       ( mov es,dx      )
  [ $89 $C3 ]       ( mov bx,ax      )
  [ $26 $8B $07 ]   ( mov ax,[es:bx] )
  [ $26 $8B $57 2 ] ( mov dx,[es:bx+2] )
;


: ^!  ( -:n => -:n )
      ( ptr => ? )
( ** Wort ber Pointer speichern ** )
  [ $C4 $1F ]     ( les bx,[bx]    )
  [ $26 $89 $07 ] ( mov [es:bx],ax )
;


: ~! ( seg:offs => seg:n )
     ( => )
     ( n => )
( ** Wort ber lange Adresse speichern ** )
  [ $8E $C2 ]     ( mov es,dx      )
  [ $89 $C3 ]     ( mov bx,ax      )
  pop
  [ $26 $89 $07 ] ( mov [es:bx],ax )
;

: ^c!  ( -:c => -:c )
       ( ptr => ? )
( ** Byte ber Pointer speichern ** )
  [ $C4 $1F ]     ( les bx,[bx]    )
  [ $26 $88 $07 ] ( mov [es:bx],al )
;


: ~c! ( seg:offs seg:c )
      ( => )
      ( c => )
( ** Byte ber lange Adresse speichern ** )
  [ $8E $C2 ]     ( mov es,dx      )
  [ $89 $C3 ]     ( mov bx,ax      )
  pop
  [ $26 $88 $07 ] ( mov [es:bx],al )
;


: ^d!  ( d => d )
       ( ptr => ? )
( ** Doppelwort ber Pointer speichern ** )
  [ $C4 $1F ]       ( les bx,[bx]      )
  [ $26 $89 $57 2 ] ( mov [es:bx+2],dx )
  [ $26 $89 $07 ]   ( mov [es:bx],ax   )
;


: ~d! ( seg:offs =>  )
      ( => )
      ( d => )
( ** Doppelwort ber lange Adresse speichern ** )
  [ $8E $C2 ]       ( mov es,dx        )
  [ $89 $C3 ]       ( mov bx,ax        )
  dpop
  [ $26 $89 $57 2 ] ( mov [es:bx+2],dx )
  [ $26 $89 $07 ]   ( mov [es:bx],ax   )
;


: ^cmove  ( nachptr:u => ?:? )
          ( vonptr => ? )
( ** u Bytes ber Pointer verschieben  ** )
( ** Bereiche drfen nicht berlappen! ** )
  [ $91 ]     ( xchg cx,ax  )
  [ $1E ]     ( push ds     )
  [ $87 $D6 ] ( xchg dx,si  )
  [ $C4 $3C ] ( les di,[si] ) ( Ziel nach es:di )
  [ $C5 $37 ] ( lds si,[bx] ) ( Quelle nach ds:si )
  [ $F3 $A4 ] ( rep movsb   ) ( Bytes bewegen )
  [ $1F ]     ( pop ds      ) ( Register zurckholen )
  [ $89 $D6 ] ( mov si,dx   )
  [ $89 $C1 ] ( mov cx,ax   )
;


: ^cfill  ( u:c => ?:? )
          ( ptr => ptr )
( ** u Bytes ber Pointer mit c setzen ** )
  [ $87 $CA ] ( xchg cx,dx  ) 
  [ $C4 $3F ] ( les di,[bx] ) ( Ziel nach es:di )
  [ $F3 $AA ] ( rep stosb   ) ( ... und fllen )
  [ $89 $D1 ] ( mov cx,dx   )
;

: ^fill  ( u:c => ?:? )
         ( ptr => ptr )
( ** u Worte ber Pointer mit n setzen ** )
  [ $87 $CA ] ( xchg cx,dx  ) 
  [ $C4 $3F ] ( les di,[bx] ) ( Ziel nach es:di )
  [ $F3 $AB ] ( rep stosw   ) ( ... und fllen )
  [ $89 $D1 ] ( mov cx,dx   )
;


: ^+!  ( -:n => ?:? )
       ( ptr => ptr )
( ** n zu Zeiger addieren ** )
  +! ^norm  ( Offset addieren und Zeiger normalisieren )
;


: ^.nil=.  ( => ) ( f )
           ( ptr -- ptr )
( ** Pointer gleich Nil ? ** )
  d@ .d0=.
;


: ^pad>  ( -:n => ?:? )
         ( ptr => ? )
( ** n Bytes von PAD ber ptr speichern ** )
  bx>tx push cs@ >dx  
  pad bx> fptr d!     ( Quellptr )
  tx>dx  pop  ^cmove
;


: ^>pad  ( -:n => ?:? )
         ( ptr => ? )
( ** n Bytes ber ptr nach PAD holen ** )
  bx>tx push cs@ >dx
  pad bx> fptr d!    ( Ziel )
  bx>dx tx>bx pop ^cmove
;


( ***** Speicherverwaltung ***** )


: GetFar  ( -:n => ?:? )
          ( ptr => ptr )
( **  Speicherblock anfordern  ** )
( ** und segadr in ptr ablegen ** )
  bx>tx           ( Pointer speichern )
  r.bx !          ( Anzahl Paragraphen )
  $48 ?msdos      ( Speicher anfordern )
  0               ( Offset = 0 )
  r.ax @>dx       ( Segmentadresse Speicherblock )
  tx>bx  d!       ( Zeiger speichern )
;


: FreeFar  ( => -:? )
           ( ptr => ? )
( ** Speicherblock freigeben ** )
  hiword @ r.es !  ( Segmentadresse setzen )
  $49 ?msdos
;


: SetFar  ( -:n => )
          ( ptr => )
( ** Gre eines Speicherblocks ndern ** )
  bx>tx
  r.bx ! tx>bx     ( Anzahl Paragraphen )
  hiword @ r.es !  ( Segmentadresse Speicherblock )
  $4A ?msdos
;


: FarAvail  ( => -:n )
            ( => ? )
( ** verfgbarer Speicher in Paragraphen ** )
  $FFFF r.bx !  ( 1 MByte anfordern )
  $48 msdos     ( Funktionsaufruf )
  r.bx @        ( verfgbare Paragraphen )
;




: MakeFar  ( -:n => )
           ( => ? )
( ** Far Memory anlegen ** )
  >dx
  FarAvail umin          ( verfgbarer Speicher )
  FarSize !              ( Heapgre in Paragraphen )  
  FarBase GetFar         ( Speicher allokieren )
  FarBase d@ FarPtr d!   ( HeapPtr initialisieren )
;

: ReleaseFar ( => )
             ( => )
( ** Durch MakeFar geffnetes Memory freigeben ** )
   FarBase  FreeFar
;

: ChangeFar  ( n => )
             ( => )
( ** Durch MakeFar geffnetes Memory ndern ** )
( ** n := Zahl der Paragraphen              ** )
   FarBase  SetFar
;

dictionary

: main init ." Hallo MEM " wait ;